package hk.quantr.logic;

import org.netbeans.api.settings.ConvertAsProperties;
import org.openide.windows.TopComponent;
import org.openide.util.NbBundle.Messages;

/**
 * Top component which displays something.
 */
@ConvertAsProperties(
		dtd = "-//hk.quantr.logic//LogicPropertyWindow//EN",
		autostore = false
)
@TopComponent.Description(
		preferredID = "LogicPropertyWindowTopComponent",
		iconBase = "hk/quantr/logic/icon_16_16.png",
		persistenceType = TopComponent.PERSISTENCE_ALWAYS
)
@TopComponent.Registration(mode = "properties", openAtStartup = false)
//@ActionID(category = "Window", id = "hk.quantr.logic.LogicPropertyWindowTopComponent")
//@ActionReference(path = "Menu/Window" /*, position = 333 */)
@TopComponent.OpenActionRegistration(
		displayName = "#CTL_LogicPropertyWindowAction",
		preferredID = "LogicPropertyWindowTopComponent"
)
@Messages({
	"CTL_LogicPropertyWindowAction=LogicPropertyWindow",
	"CTL_LogicPropertyWindowTopComponent=LogicPropertyWindow Window",
	"HINT_LogicPropertyWindowTopComponent=This is a LogicPropertyWindow window"
})
public final class LogicPropertyWindowTopComponent extends TopComponent {

	public LogicPropertyWindowTopComponent() {
		initComponents();
		setName(Bundle.CTL_LogicPropertyWindowTopComponent());
		setToolTipText(Bundle.HINT_LogicPropertyWindowTopComponent());

	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
	@Override
	public void componentOpened() {
		// TODO add custom code on component opening
	}

	@Override
	public void componentClosed() {
		// TODO add custom code on component closing
	}

	void writeProperties(java.util.Properties p) {
		// better to version settings since initial version as advocated at
		// http://wiki.apidesign.org/wiki/PropertyFiles
		p.setProperty("version", "1.0");
		// TODO store your settings
	}

	void readProperties(java.util.Properties p) {
		String version = p.getProperty("version");
		// TODO read your settings according to their version
	}
}
